//-----------------------------------------------------------------------------
//
// RPanelInfo.cpp
//
// Reusable file and save panel information class.
//
// Shared by threads. Must be locked whenever accessed via the "Lock" and 
// "Unlock" member functions. The app thread and window threads may obtain the // lock. To prevent deadlocks, while you have the lock, you must not lock the 
// app or any windows.
//
//-----------------------------------------------------------------------------

#include "RPanelInfo.h"

B_DEFINE_CLASS_INFO(RPanelInfo, BObject);

///RPanelInfo
//-----------------------------------------------------------------------------

RPanelInfo::RPanelInfo()
{
	dir.database = dir.record = -1;
	// It would be nice to initialize frame here too, but you can't get 
	// screen info until the app is running, so you have to do it in the app 
	// constructor instead.
}

///Lock
//-----------------------------------------------------------------------------

void RPanelInfo::Lock()
{
	lock.Lock();
}

///Unlock
//-----------------------------------------------------------------------------

void RPanelInfo::Unlock()
{
	lock.Unlock();
}
