#ifndef TCompile_H
#define TCompile_H

#ifndef TGlobals_H
#include "TGlobals.h"
#endif

class TCStatus;
class TRunner;

typedef struct TRunnerInfo {
	TRunner *runner;
	bool busy;
	bool dead;
	char name[B_FILE_NAME_LENGTH+1];
	bool linking;
};

class TCompile : public BLooper 
{
	B_DECLARE_CLASS_INFO(BLooper);
public:
	TCompile();
	void Compile(record_ref ref);
	void Quit();
private:
	void MessageReceived(BMessage *msg);
	bool StartCompile(record_ref ref);
	bool FinishCompile(long result, char *data);
	void StartLink();
	bool FinishLink(long result, char *data);
	void RunApp();
	void StartMake(BMessage *msg);
	void StartNextMakeStep();
	void InitRunners();
	void UpdateStatus();
	
	TCStatus *status;
	TRunnerInfo runnerInfo[MAX_RUNNERS];
	long numRunners;
	bool making;
	BList *compile;
	BList *link;
	bool run;
};

#endif
