#ifndef TDepend_H
#define TDepend_H

class TProjectInfo;
class RDirectory;
class TModule;

class TDepend : public BLooper 
{
	B_DECLARE_CLASS_INFO(BLooper);
public:
	TDepend();
	void SetProject(record_ref ref);
	void SetProject();
	void CreateMakeFile();
	void UpdateIncludeFileDependencies(const record_ref ref, 
		const char *text, const long len);
	void Make();
	void MakeAndRun();
	void WriteIncludesAndQuit();
private:
	void MessageReceived(BMessage *msg);
	void DoSetProject(record_ref ref);
	void DoMake(bool run);
	bool ModDateNewer(long mod, BList &dep);	
	void DoCreateMakeFile();
	char *WriteCPPOBJS(char *p);
	char *WriteOBJS(char *p, bool xincludes);
	char *WriteDeps(BList &dep, char *p);
	void InitDependencies();
	void DoUpdateIncludeFileDependencies(BMessage *msg);
	BMessage *BuildMessageListingIncludes(const char *text, const long len);
	TModule *FindModule(const char *name);
	void ReadIncludes();
	void DoWriteIncludes();
	
	BList modules;			// list of project modules, type list of TModule*
							// first entry is always the app module
							
	bool dependsInited;		// TRUE if modules list is complete
	
	BList includes;			// list of cached header file include info
							// from database, type list of TIncludes*
							
	BList includesData;		// list of include info database buffers read, type
							// list of char*. These data buffers are pointed
							// into by the elements of includes.
							
	bool haveIncludes;		// TRUE if we have read the cached header file 
							// include info from the database
};

#endif
