#ifndef	TFindDlg_H
#define	TFindDlg_H

#ifndef TWindow_H
#include "TWindow.h"
#endif

#ifndef TFindInfo_H
#include "TFindInfo.h"
#endif

class TFindDlg : public BWindow
{
	B_DECLARE_CLASS_INFO(BWindow);
public:
	TFindDlg(TWindow *parent);
private:
	void MessageReceived(BMessage *msg);
	bool FilterKeyDown(ulong *aChar, BView **target);
	void MakeTextEntryField(BRect labelRect, const char *label,
		BView *container, const char *name, bool makeFocus, 
		const char *initValue);
	BCheckBox *MakeOptBox(BRect *frame, const char *label, 
		const ulong what, BView *container, bool initValue);
	void MakeDirRadio(BRect *frame, const char *label,
		BView *container, bool forward);
	void MakeScopeRadio(BRect *frame, const char *label,
		const ulong what, BView *container, TFindScope scope);
		
	TWindow *parent;			// parent window
	record_ref parentRef;		// record ref of parent window
	bool caseSensitive;			// TRUE if case sensitive option on
	bool wholeWord;				// TRUE if whole word option on
	bool wrap;					// TRUE if wrap option on
	bool forward;				// TRUE if forward, FALSE if backwards
	TFindScope scope;			// search scope
	bool haveProjectDir;		// TRUE if we have a project directory
	BCheckBox *wrapCheckBox;	// pointer to wrap option checkbox
};

#endif