#ifndef	TFindInfo_H
#define	TFindInfo_H

class RDirectory;

typedef enum {
	FIND_THIS_FILE,
	FIND_CPP_FILES,
	FIND_H_FILES,
	FIND_CPP_AND_H_FILES,
	FIND_TEXT_FILES,
	FIND_BE_HEADER_FILES,
	FIND_STD_C_HEADER_FILES
} TFindScope;

typedef struct TFindFileListElement {
	record_ref ref;
	char name[B_FILE_NAME_LENGTH+1];
} TFindFileListElement;

class TFindInfo : public BObject {
	B_DECLARE_CLASS_INFO(BObject);
public:
	TFindInfo();
	void Lock();
	void Unlock();
	void BuildFileList(record_ref parentRef);
	
	char *searchString;		// search string
	char *replaceString;	// replace string
	bool caseSensitive;		// TRUE if case sensitive option on
	bool wholeWord;			// TRUE if whole word option on
	bool wrap;				// TRUE if wrap option on
	bool forward;			// TRUE if forward, FALSE if backwards
	TFindScope scope;		// search scope
	BList list;				// list of files to search
	long pos;				// current position in file list
private:
	void AddDirContentsToFileList(RDirectory *dir);
	static int CompareItems(const void *a, const void *b);
	bool FileInScope(BFile &file, const char *name);
	BLocker lock;
};

#endif