#ifndef TProjectInfo_H
#define TProjectInfo_H

class RDirectory;
class RFile;
class RWriteLocker;

class TProjectInfo : public BObject 
{
	B_DECLARE_CLASS_INFO(BObject);
public:
	TProjectInfo();
	~TProjectInfo();
	TProjectInfo &operator=(const TProjectInfo &rhs);
	void ReadLock();
	void ReadUnlock();
	void WriteLock();
	void WriteUnlock();
	long GetDirectory(const long dirIndex, RDirectory *dir);
	long GetObjDirectory(const long dirIndex, RDirectory *objDir);
	long GetPrimaryFile(const char *name, RFile *file);
	long GetFile(const long index, RFile *file, long *dirIndex = NULL);
	long GetFile(const char *name, RFile *file, long *dirIndex = NULL);
	long GetObjFile(const long index, RFile *file, long *dirIndex = NULL);
	long GetObjFile(const char *name, RFile *file, long *dirIndex = NULL);
	bool SetProjectInfo(record_ref ref);
	
	bool haveProject;
	char *shell;
	char *beIncludes;
	char *includes;
	char *obj;
	char *app;
	char *cc;
	char *cflags;
	char *ld;
	char *ldflags;
	char *beHeaders;
	long numCompileThreads;
	
private:
	long AddObjDirs();
	void MakeEmpty();
	void ReadProjectFile(RDirectory *dir);
	void ParseOneVariable(const char *data, const char *name, char **v);
	void ParseSecondaryDirectories(RDirectory *dir, const char *data);
	
	BList dirs;					// List of project dirs, 
								// type list of RDirectory*
	BList objs;					// List of object dirs, 
								// type list of RDirectory*
	static RWriteLocker lock;	// Lock
};

#endif
