#ifndef TTextView_H
#define TTextView_H

#ifndef RTextView_H
#include "RTextView.h"
#endif
#ifndef TUndo_H
#include "TUndo.h"
#endif

class TUndo;

class TTextView : public RTextView 
{
	B_DECLARE_CLASS_INFO(RTextView);
public:
	TTextView(BRect frame);
	bool CanReplace();
	bool CanUndo() {return undo.CanUndo();};
	void ClearUndo() {undo.Clear();};
	void MoveUp();
	void MoveDown();
private:
	TUndo undo;
	void AttachedToWindow();
	void KeyDown(ulong aChar);
	void FrameResized(float width, float height);
	bool BreaksAtChar(ulong aChar) const;
	void Cut(BClipboard *clipboard);
	void Paste(BClipboard *clipboard);
	void MessageReceived(BMessage *msg);
	void SetDirty();
	void AdjustScrollBar();
	bool FindAgain(bool replaceAll);
	bool SearchCurrentFile(long start, long finish);
	bool Replace();
	void ReplaceAll();
	void GoToLine(long line, bool emess);
	void GoToMarker(const char *marker);
	void IndentOrComment(ulong what);
	void GetExpandedSelection(long *start, long *finish);
	void EnterSelection(char **str);
	void MakeCString();
};

#endif
