//-----------------------------------------------------------------------------
//
// TUtil.cpp
//
// Utility functions.
//
//-----------------------------------------------------------------------------

#include "TUtil.h"

///IsDotCpp
//-----------------------------------------------------------------------------

bool IsDotCpp(const char *name)
{
	long len = strlen(name);
	return len > 4 && strcmp(name+len-4, ".cpp") == 0;
}

bool IsDotCpp(BFile &file)
{
	char name[B_FILE_NAME_LENGTH+1];
	if (file.GetName(name) != B_NO_ERROR) return FALSE;
	return IsDotCpp(name);
}

bool IsDotCpp(const record_ref ref)
{
	BFile file(ref);
	return IsDotCpp(file);
}

///IsDotH
//-----------------------------------------------------------------------------

bool IsDotH(const char *name)
{
	long len = strlen(name);
	return len > 2 && strcmp(name+len-2, ".h") == 0;
}

bool IsDotH(BFile &file)
{
	char name[B_FILE_NAME_LENGTH+1];
	if (file.GetName(name) != B_NO_ERROR) return FALSE;
	return IsDotH(name);
}

bool IsDotH(const record_ref ref)
{
	BFile file(ref);
	return IsDotH(file);
}

///IsProjectFile
//-----------------------------------------------------------------------------

bool IsProjectFile(const char *name)
{
	return strcmp(name, "project") == 0;
}

bool IsProjectFile(BFile &file)
{
	char name[B_FILE_NAME_LENGTH+1];
	if (file.GetName(name) != B_NO_ERROR) return FALSE;
	return IsProjectFile(name);
}

bool IsProjectFile(const record_ref ref)
{
	BFile file(ref);
	return IsProjectFile(file);
}
