#ifndef TWindow_H
#define TWindow_H

#ifndef RWindow_H
#include "RWindow.h"
#endif

class RFile;

class TWindow : public RWindow 
{
	B_DECLARE_CLASS_INFO(RWindow);
	friend class TTextView;
public:
	TWindow(const void *data = NULL, const long size = 0, 
		const bool readonly = FALSE, const database_id database = -1, 
		const record_id record = -1, char *title = NULL,
		long start = 0, long finish = 0);
	record_ref Ref();
	bool Save(ulong what);
	void HidePanel();
private:
	void CreateMenuBar(BRect &menuBarFrame);
	void CreatePanelView(BRect &menuBarFrame);
	TTextView *CreateScrollView(BRect &menuBarFrame);
	void Stagger(TTextView *text);
	void SetProjectDir(BFile &file);
	bool QuitRequested();
	void MenusWillShow();
	void MessageReceived(BMessage *msg);
	void SavePanelClosed(BMessage *msg);
	void SaveRequested(record_ref directory, const char *fileName);
	void Init(const char *title, const char *data = NULL, const long size = 0);
	void SaveTextToFile(RFile &file);
	void BuildMarkersMenu();
	void RevertToSaved();
	void OpenPartner();
	void GetInfo();
	void SetDirty(bool flag);
	void DisplayCompilerErrorMessage(const char *emess1, 
		const char *emess2, const char *emess3);
	static long untitledCount;
	record_ref ref;
	bool dirty;
	bool readonly;
	bool scrollToMiddleAfterNextResizeHack;
};

#endif
 